package org.apache.poi.ss.formula.functions;

import org.apache.poi.ss.formula.*;
import org.apache.poi.ss.formula.functions.*;
import org.apache.poi.ss.formula.eval.*;

public class PPMT extends NumericFunction {

	@Override
	public double eval(ValueEval[] args, int srcCellRow, int srcCellCol) throws EvaluationException {
   		
		System.out.println("srcCellRow="+srcCellRow);
		System.out.println("srcCellCol="+srcCellCol);
		for(ValueEval arg: args)
			System.out.println("arg="+arg);

		if(args.length != 4) 
        		throw new EvaluationException(ErrorEval.VALUE_INVALID);

		double result;

		ValueEval v1 = OperandResolver.getSingleValue(args[0], srcCellRow, srcCellCol);
                ValueEval v2 = OperandResolver.getSingleValue(args[1], srcCellRow, srcCellCol);
                ValueEval v3 = OperandResolver.getSingleValue(args[2], srcCellRow, srcCellCol);
                ValueEval v4 = OperandResolver.getSingleValue(args[3], srcCellRow, srcCellCol);

		//System.out.println("v1="+v1);
		//System.out.println("v2="+v2);
		//System.out.println("v3="+v3);
		//System.out.println("v4="+v4);

		double interestRate = OperandResolver.coerceValueToDouble(v1);
                int period = OperandResolver.coerceValueToInt(v2);
                int numberPayments = OperandResolver.coerceValueToInt(v3);
                double PV = OperandResolver.coerceValueToDouble(v4);

		//System.out.println("interestRate="+interestRate);
		//System.out.println("period="+period);
		//System.out.println("numberPayments="+numberPayments);
		//System.out.println("PV="+PV);

		result = Finance.ppmt(interestRate, period, numberPayments, PV) ;
		System.out.println("result=" + result);
				
		checkValue(result);
		
		System.out.println("PPMT=" + result);
		return result;
	}

	

}
